import cgi

from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.ext import db
from google.appengine.api import urlfetch

import wsgiref.handlers

class tileStorage(db.Model):
  tileLayer = db.StringProperty()
  tileID = db.StringProperty()
  tileImg = db.BlobProperty(default=None)


class insertTile(webapp.RequestHandler):
  def get(self):
    
	myLayer = self.request.get('layer')
	myID = self.request.get('tileID')
	myURL = self.request.get('url')
	myURL = myURL.replace('XXX','&')
	
	oneTile = tileStorage()
	oneTile.tileLayer = myLayer
	oneTile.tileID = myID
	oneTile.tileImg = db.Blob(urlfetch.Fetch(myURL).content)
	oneTile.put()
	
	self.response.out.write('Tile is added!')
	
class getTile(webapp.RequestHandler):
  def get(self):
 	
	myLayer = self.request.get('layer')
	myID = self.request.get('tileID')
	imgType = self.request.get('imgType')
	
	oneTile = getOneTile(myLayer, myID)
	if (oneTile and oneTile.tileImg):
		self.response.headers['Content-Type'] = imgType
		self.response.out.write(oneTile.tileImg)
	#else:
	#	self.redirect('/static/noimage.jpg')

class checkTile(webapp.RequestHandler):
  def get(self):
	myLayer = self.request.get('layer')
	myID = self.request.get('tileID')
	oneTile = getOneTile(myLayer, myID)
	if (oneTile and oneTile.tileImg):
		self.response.out.write('true')
	else:
		self.response.out.write('false')
		

def getOneTile(myLayer, myID):
  result = db.GqlQuery("SELECT * FROM tileStorage WHERE tileLayer = :1 AND tileID = :2 LIMIT 1", myLayer, myID).fetch(1)
  if (len(result) > 0):
    return result[0]
  else:
    return None


application = webapp.WSGIApplication(
                                     [('/insertTile', insertTile),('/getTile', getTile),('/checkTile', checkTile)],
                                     debug=True)


def main():
  run_wsgi_app(application)

if __name__ == "__main__":
  main()